#include "csvparse.h"

CSVParse::CSVParse(char *filePath, bool isComplex)
{
    this->file.open(filePath, std::ios_base::in);

    if(file.is_open()) {
        std::string line;
        uint16_t count = 0;
        while(std::getline(file,line)) {
            count++;
        }
        this->nbLines = count;
        file.clear();
        file.seekg(0, std::ios_base::beg);

        signal = new std::complex<double>[count];
        std::size_t imPointer = 0;
        count = 0;
        while(std::getline(file, line)) {
            signal[count].real(std::stod(line, &imPointer));
            if(isComplex) {
                signal[count].imag(std::stod(line.substr(imPointer+1)));
            }
            count++;
        }

        this->valid = true;
    }
}

CSVParse::~CSVParse() {
    delete[] signal;
}
