#include "dsp.h"

namespace DSP {
    using namespace std;

    complex<double> * convol(complex<double> * signal, complex<double> * kernel, uint16_t sig_size, uint16_t kernel_size) {
        complex<double> * out = new complex<double>[sig_size];

        for(uint16_t i = 0; i < sig_size; i++) {
            complex<double> tmp(0,0);
            for(uint16_t j = 0; j+i < sig_size; i++) {
                tmp += signal[i + j] * kernel[j];
            }
            out[i] = tmp;
        }

        return out;
    }

    void pointDFT(complex<double> * sig1, complex<double> * sig2, double Fc, double Fs, uint16_t sig_size, complex<double> * sig1_pc, complex<double> * sig2_pc) {

        double step = 2*Pi*Fc/Fs;
        const std::complex<double> i(0, 1);

        complex<double> *refsine = new complex<double>[sig_size];
        for(uint16_t k = 0; k < sig_size; k++) {
            refsine[k] = conj(exp(i*step*(double)k));
        }

        complex<double> sig1_p(0,0);
        complex<double> sig2_p(0,0);
        for(uint16_t k = 0; k < sig_size; k++) {
            sig1_p += sig1[k] * refsine[k];
            sig2_p += sig2[k] * refsine[k];
        }

        *sig1_pc = sig1_p;
        *sig2_pc = sig2_p;

        delete[] refsine;

        return;
    }

    complex<double> * PLLLock(const complex<double> * refSig, uint64_t len) {
        double sFreq = 1e6; // Starting Frequency



    }


}

HBT::HBT(uint64_t len) {
}

HBT::~HBT() {

}

std::complex<double> * HBT::HTsfrm(const complex<double> * refSig) {
    fftw_complex * in = reinterpret_cast<fftw_complex*>(refSig);
}
