#ifndef DSP_H
#define DSP_H

#include <complex>
#include <fftw3.h>

namespace DSP {
    using namespace std;
    const double Pi = 3.14159265358979323846;

    complex<double> * convol(complex<double> * signal, complex<double> * kernel, uint16_t sig_size, uint16_t kernel_size);
    void pointDFT(complex<double> * sig1, complex<double> * sig2, double Fc, double Fs, uint16_t sig_size, complex<double> * sig1_pc, complex<double> * sig2_pc);
    complex<double> * PLLLock(const complex<double> * refSig, uint64_t len);
}

class HBT {
public:
    HBT(uint64_t len);
    ~HBT();
    std::complex<double> HTsfrm(const std::complex<double> * refSig, uint64_t len);

private:
    uint64_t len;
    fftw_plan p;
    fftw_complex * in;
    fftw_complex * out;
};

#endif // DSP_H
