﻿using FTD2XX_NET;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ftdi_test
{
    public partial class Form1 : Form
    {
        FTDI.FT_STATUS ftStatus = FTDI.FT_STATUS.FT_OK;
        FTDI VNA;
        uint devcount; // Number of FTDI devices

        public Form1()
        {
            InitializeComponent();
        }

        private void bConnect_Click(object sender, EventArgs e)
        {
            try
            {
                VNA = new FTDI();
                ftStatus = VNA.GetNumberOfDevices(ref devcount);
            }
            catch
            {
                tStatus.Text = "No Drivers !";
            }

            ftStatus = VNA.OpenByIndex(0);
            if (ftStatus != FTDI.FT_STATUS.FT_OK)
            {
                tStatus.Text = "No FTDI";
                return;
            } else
            {
                tStatus.Text = "FTDI on Index 0";
            }

            byte mask = 0x00;
            byte mode = 0x40;

            ftStatus = VNA.SetBitMode(mask, mode);
            if (ftStatus != FTDI.FT_STATUS.FT_OK)
            {
                tStatus.Text = "Can't set FT245 mode";
                return;
            }
            else
            {
                tStatus.Text = "FT245 Mode activated";
            }

            bCMD.Enabled = true;
        }

        public static byte[] StringToByteArray(String hex)
        {
            int NumberChars = hex.Length;
            byte[] bytes = new byte[NumberChars / 2];
            for (int i = 0; i < NumberChars; i += 2)
                bytes[i / 2] = Convert.ToByte(hex.Substring(i, 2), 16);
            return bytes;
        }

        private void bCMD_Click(object sender, EventArgs e)
        {
            uint wrote = 0;
            uint red = 0;
            uint toread = 0;

            foreach (string line in tCMD.Lines)
            {
                var a = StringToByteArray(line);
                ftStatus = VNA.Write(a, (uint)a.Length, ref wrote);
                uint l = (uint)a.Length - wrote;
                if (l != 0)
                {
                    tStatus.Text = "Didn't send all the bytes";
                }
            }
            System.Threading.Thread.Sleep(100);
            ftStatus = VNA.GetRxBytesAvailable(ref toread);
            if (toread != 0)
            {
                byte[] rxstr = new byte[65535];
                ftStatus = VNA.Read(rxstr, toread, ref red);
                tRX.Text = System.Text.Encoding.UTF8.GetString(rxstr, 0, rxstr.Length);
            }
            else
            {
                tRX.Text = "No data back";
            }
        }

        private void bADC_Click(object sender, EventArgs e)
        {
            uint wrote = 0;
            byte[] ADCregs = { 0x03, 0x00, 0x80, 0x03, 0x02, 0x01, 0x03, 0x03, 0xFF, 0x03, 0x04, 0xFF, 0x03, 0x01, 0x20 };
            ftStatus = VNA.Write(ADCregs, (uint)ADCregs.Length, ref wrote);
        }

        private void bRADC_Click(object sender, EventArgs e)
        {
            uint wrote = 0;
            byte[] ADCread = { 0x04 };
            ftStatus = VNA.Write(ADCread, (uint)ADCread.Length, ref wrote);
            int red = 0;
            uint tmp = 0;
            byte[] bytes = new byte[8096];
            byte[] tmpb = new byte[8096];
            System.Threading.Thread.Sleep(1000);
            while (red < 4000 - 1)
            {
                ftStatus = VNA.GetRxBytesAvailable(ref tmp);
                if (tmp == 0) break;
                uint tr = 0;
                ftStatus = VNA.Read(tmpb, tmp, ref tr);
                for(int i = 0; i < tr; i++)
                {
                    bytes[red + i] = tmpb[i];
                }
                red = red + (int)tr;
            }
            Int16[] chan1 = new Int16[2500];
            Int16[] chan2 = new Int16[2500];
            for (int j = 0; j < red; j+=4)
            {
                chan1[j / 4] = (Int16)((UInt16)(bytes[j] << 8) | (UInt16)(bytes[j + 1]));
                chan2[j / 4 + 1] = (Int16)((UInt16)(bytes[j+2] << 8) | (UInt16)(bytes[j + 3]));

                //chan1[j / 4] = (Int16)((UInt16)(bytes[j]) | (UInt16)(bytes[j + 1] << 8));
                //chan2[j / 4 + 1] = (Int16)((UInt16)(bytes[j + 2]) | (UInt16)(bytes[j + 3] << 8));
            }
            uint v = 0;
        }
    }
}
