close all;
clear;
% Phase comparator prototype
% Use "fast correlation" because tangente based system is doomed !

Fs = 96000;     % Sampling Freq
Fc = 9600;     % Signal Carrier

Plen = 100;                     % Period Length
rplen = round(Fs/Fc * Plen);    % Period Length in Sample
N = (1:rplen);

Ps = 10;                 % Phase shit in degree
rps = (Ps/360) * (Fs/Fc); % Phase shift in sample
A = db2pow(10);            % Power in dB

refcos = cos(2*pi*(N-1)*((Fc+0.0)/Fs));
sigcos = awgn(A.*sin(2*pi*(N-1-rps)*((Fc+0.0)/Fs)), 100, 'measured'); % add noise

crcos = hilbert(refcos);
cscos = hilbert(sigcos);

cscor = sum(cscos .* conj(crcos))/rplen;    % Compute the DFT of the signal on target frequency only

csphase = 180 * ((atan2(imag(cscor), real(cscor)))/pi); % Compute the phase shift in degree

csamp = pow2db(sqrt(imag(cscor)^2 + real(cscor)^2)); % Compute the relative power in dB

ZRef = 50; % Reference Impedance

Zin = ((1+cscor) / (1-cscor)) * ZRef;
Zin_denorm = ((1+cscor) / (1-cscor));

% Handle deembedding with digital "electrical delay"
line_len = 20; % Cable length in mm
ca_len = line_len / 1000; % Cable length in m

c0 = 299792458;
c_rg142 = c0 * 69.2 / 100;
z_rg142 = 50;
cap_meter = 96.46 / 1e12;

% let's say our example is at 4GHz we could add losses too
freq_sig = 2.4e9;

beta_line = (2*pi*freq_sig)/c_rg142;

true_Z = (z_rg142*(z_rg142*tanh(beta_line*ca_len)-Zin))/(tanh(beta_line*ca_len)*Zin-z_rg142);

%true_Z = z_rg142 * (Zin - 1i*(z_rg142*tan(beta_line*ca_len)))/(z_rg142 - 1i*(Zin*tan(beta_line*ca_len)));
