close all;
clear;
% PLL prototype

Fs = 100000;     % Sampling Freq
Fc = 10000;     % Signal Carrier

Plen = 5000;                     % Period Length
rplen = round(Fs/Fc * Plen);    % Period Length in Sample
N = (1:rplen);

Ps = 90;                 % Phase shit in degree
rps = (Ps/360) * (Fs/Fc); % Phase shift in sample
rad_phase = (Ps/360)*2*pi;
A = db2pow(0);            % Power in dB

refcos = cos(2*pi*(N-1)*(Fc/Fs));
refsin = sin(2*pi*(N-1)*(Fc/Fs));
sigcos = awgn(A.*cos(2*pi*(N-1-rps)*((Fc+1000)/Fs)), 1000, 'measured'); % add noise

crcos = hilbert(refcos);
crsin = hilbert(refsin);
cscos = hilbert(sigcos);

a = (crcos.*cscos) .* (crsin.*cscos);

test_cos = (1:rplen);
test_out = (1:rplen);
test_sig = (1:rplen);
test_corr = (1:rplen);
test_insterr = (1:rplen);
test_phase = (1:rplen);
test_diff = (1:rplen);
test_angle = (1:rplen);
test_integ = (1:rplen);
test_instfreq = zeros(1,rplen);

insterror = 0;
error = 0;
freq_corr = 0;
phase_corr = 0;

of_coef = 128000; % Old Frequencies coefficients
op_coef = 64000; % Old Phase coefficients
cf_coef = 4096; % Current Frequency coefficients
cp_coef = 8; % Current Frequency coefficients

old_cos = 0;
branch_log = zeros(1,rplen);

integ_len = Fs/Fc*10;
phase_shifter = zeros(1,integ_len);%(1:integ_len);

for index = 1:rplen
   % This part can be replace by a multiplication to rotate the vector
   osc_cos = exp(1i*(2*pi*((Fc+freq_corr)/Fs)*(index)));%+phase_corr));
   
   input_sig = exp(1i*(2*pi*((Fc)/Fs)*(index)+rad_phase));
   
   error = input_sig * conj(osc_cos);           % error angle
   insterror = atan2(imag(error), real(error));
   
   branch_log(index) = 0;
%    if (insterror > pi/16) % Avoid over correcting frequency when error is small
%       freq_corr = freq_corr/of_coef + ((insterror*Fs)/(2*pi))/cf_coef; % Error to Hertz
%       phase_corr = phase_corr/op_coef + insterror/cp_coef;
%       branch_log(index) = 1;
%    elseif (insterror < -pi/16)
%       freq_corr = freq_corr/of_coef - ((insterror*Fs)/(2*pi))/cf_coef; % Error to Hertz
%       phase_corr = phase_corr/op_coef - insterror/cp_coef;
%       branch_log(index) = -1;
%    end

   %phase_shifter(1:end-1) = phase_shifter(2:end);
   %phase_shifter(end) = insterror;
   %int_error = sum(phase_shifter)/integ_len;
   
   if (insterror > 0)
       branch_log(index) = 1;
       freq_corr = freq_corr + ((insterror*Fs)/(2*pi))/cf_coef;
   elseif (insterror < 0)
       branch_log(index) = -1;
       freq_corr = freq_corr + ((insterror*Fs)/(2*pi))/cf_coef;
   end
   
   %
   if(freq_corr >= 3000)
       freq_corr = 3000;
   elseif(freq_corr <= -3000)
       freq_corr = -3000;
   end
   
   % debug diff phase
   diff_cos = osc_cos * conj(old_cos);
   diff_angle = atan2(imag(diff_cos), real(diff_cos));
   old_cos = osc_cos;
   
   test_instfreq(index) = ((insterror*Fs)/(2*pi))/cf_coef;
   test_insterr(index) = insterror;
   test_diff(index) = diff_angle;
   test_cos(index) = osc_cos;
   test_sig(index) = input_sig;
   test_corr(index) = freq_corr;
   test_phase(index) = phase_corr;
   test_angle(index) = error;
   test_integ(index) = sum(phase_shifter)/integ_len;
end

% plot(real(test_insterr));
% hold on;
% %plot(real(test_out));
% hold on;
% plot(real(test_corr));

start_plot = 3200;
end_plot = 4000;

% polarplot(test_cos(start_plot:end_plot));
% hold on;
% polarplot(test_sig(start_plot:end_plot));

% figure();
% plot(test_insterr(start_plot:end_plot));
% hold on;
% plot(test_diff(start_plot:end_plot));
% hold on;
% plot(branch_log(start_plot:end_plot));
% hold on;
% plot(test_angle(start_plot:end_plot));
% legend('instantaneous error', 'n - n-1','branch', 'angle');
% grid on
% grid minor

% test disp
% bouh = [test_cos(start_plot:end_plot);test_sig(start_plot:end_plot);test_angle(start_plot:end_plot);test_diff(start_plot:end_plot)];
% 
% figure();
% polarplot(bouh(1,1:50),'-*');
% hold on;
% polarplot(bouh(2,1:50),'-*');
% hold on;
% polarplot(bouh(3,1:50),'-*');
% hold on;
% polarplot(bouh(4,1:50),'-*');
% grid on;
% grid minor;
% legend('test cos', 'test sig', 'test angle', 'test diff');
% 
% figure(); plot(test_corr(start_plot:end_plot)/1000);
% hold on;
% plot(test_phase(start_plot:end_plot));
% hold on;
% plot(branch_log(start_plot:end_plot));
% legend('frequency correction', 'phase correction','branch');
% grid on 
% grid minor

figure();
plot(test_diff);
hold on;
plot(branch_log);
hold on;
plot(test_insterr);
hold on;
plot(test_integ);
hold on;
plot(test_corr/100);
legend('arg(n) - arg(n-1)', 'branch', 'instantaneour error', 'error integration', 'Frequency correction');