%close all;
clear;
% PLL prototype

Fs = 10000;     % Sampling Freq
Fc = 1000;     % Signal Carrier

Plen = 5000;                     % Period Length
rplen = round(Fs/Fc * Plen);    % Period Length in Sample
N = (1:rplen);

Ps = 40;                 % Phase shit in degree
rad_phase = (Ps/360)*2*pi;

Foffset = 100;             % Freq offset

freq_corr = 0;
phase_corr = 0;

freq_ratio = 4096;
phase_ratio = 2048;

% debug var
osc = zeros(1,rplen);
sig = zeros(1,rplen);
err = zeros(1,rplen);
ang = zeros(1,rplen);
cor = zeros(1,rplen);
fre = zeros(1,rplen);

osc_ang = zeros(1,rplen);
sig_ang = zeros(1,rplen);

for index = 1:rplen
   osc_ang(index) = 2*pi*mod(((Fc+freq_corr)/Fs)*(index)+phase_corr, 1);

   osc_cos = exp(1i*(osc_ang(index)));
   
   sig_ang(index) = wrapTo2Pi(2*pi*((Fc+Foffset)/Fs)*(index)+rad_phase);
   input_sig = exp(1i*(sig_ang(index)));
   
   error = input_sig * conj(osc_cos);
   
   insterror = atan2(imag(error), real(error));
   instfreq = (insterror * Fs)/(2*pi);
   
   freq_corr = freq_corr + (instfreq/freq_ratio);
   phase_corr = phase_corr + insterror/phase_ratio;
   
   osc(index) = osc_cos;
   sig(index) = input_sig;
   ang(index) = insterror;
   err(index) = error;
   cor(index) = freq_corr;
   fre(index) = instfreq;
end

real_osc = real(osc) + imag(osc);
real_sig = real(sig) + imag(sig);

figure();
plot(ang);
hold on;
plot(cor/1000);
hold on;
plot(fre/1000);
hold on;
plot(real_osc);
hold on;
plot(real_sig);
hold on;
legend('ang', 'cor', 'fre', 'osc', 'sig');

