close all;
clear;
% PLL prototype

Fs = 1000;     % Sampling Freq
Fc = 100;     % Signal Carrier

Plen = 5000;                     % Period Length
rplen = round(Fs/Fc * Plen);    % Period Length in Sample
N = (1:rplen);

Ps = 1;                 % Phase shit in degree
rad_phase = (Ps/360)*2*pi;

Foffset = 0;             % Phase offset

freq_corr = 0;
phase_corr = 0;

freq_ratio = 128;
phase_ratio = 128;

pond_err = 0;
oldK = 0.9;
newK = 0.001;

% debug var
osc = zeros(1,rplen);
sig = zeros(1,rplen);
err = zeros(1,rplen);
ang = zeros(1,rplen);
cor = zeros(1,rplen);
fre = zeros(1,rplen);

for index = 1:rplen
   osc_cos = exp(1i*(2*pi*((Fc+freq_corr)/Fs)*(index)+phase_corr));
   
   input_sig = exp(1i*(2*pi*((Fc+Foffset)/Fs)*(index)+rad_phase));
   
   error = input_sig * conj(osc_cos);
   pond_err = oldK*pond_err + newK*error;
   
   insterror = atan2(imag(pond_err), real(pond_err));
   instfreq = (insterror * Fs)/(2*pi);
   
   freq_corr = freq_corr + instfreq/freq_ratio;
   phase_corr =0;%= phase_corr + insterror/phase_ratio;
   
   osc(index) = osc_cos;
   sig(index) = input_sig;
   ang(index) = insterror;
   err(index) = error;
   cor(index) = freq_corr;
   fre(index) = instfreq;
end

plot(ang);
hold on;
plot(err);
hold on;
plot(cor);
hold on;
plot(fre);
hold on;
legend('ang', 'err', 'cor', 'fre');

