clear;
Fs = 20e6;
Fc = 800e3;

nbSample = 1000;
t = (1:nbSample);

nbFiles = 250;
write_name = "PERFECTLOAD";

for k = 0:nbFiles-1

    carPow = 0;
    carVpp = 0.6324555320*exp(0.1151292546*carPow);
    carrier = cos(2*pi*(Fc/Fs)*t)*carVpp;

    Z0 = 50;
    Z = 1+1*1i;

    refAttn = 0;
    refVpp = 0.6324555320*exp(0.1151292546*(carPow-refAttn));
    refSNR = 0;
    ref = cos(2*pi*(Fc/Fs)*t)*refVpp;
    %ref = awgn(ref, refSNR, refAttn * -1);
    
    sigAttn = 0;
    sigVpp = 0.6324555320*exp(0.1151292546*(carPow-refAttn));
    sigSNR = 0;
    phase = 0;
    sig = cos(2*pi*(Fc/Fs)*t+phase)*refVpp;
    sig = awgn(sig, sigSNR, sigAttn * -1);
    
    ref = round(ref*65535);
    sig = round(sig*65535);
    
    pair2w = [ref', sig'];
    
    write_path = [ "..\..\..\..\vnadump\S11_" , write_name , "\" , int2str(k), ".csv" ];
    folder_path = [ "..\..\..\..\vnadump\S11_" , write_name ];
    mkdir(strjoin(folder_path, ''));
    dlmwrite(strjoin(write_path, ''), pair2w, ';');
    
    subplot(2,1,1);
    plot(mag2db(abs(fft(sig)/1000)));
    hold on;
    
    subplot(2,1,2);
    plot(mag2db(abs(fft(ref)/1000)));
    hold on;
end