function [carrier,endfreq] = pll(sig, len, Fc, Fs)
    % Fast PLL see: http://liquidsdr.org/blog/pll-simple-howto/
    phasecoef = 0.05;
    freqcoef = 0.5 * phasecoef^2;
    
    pcorr = 0;
    fcorr = 0;
    
    phref = 2*pi*(Fc/Fs);
    %phref = 2*pi*(0/Fs);
    
    osc_ref = zeros(1,len);
    
    % debugging
    insterror = zeros(1,len);
    fcorrd = zeros(1,len);

    for j = 1:len
        osc_ref(j) = exp((phref+pcorr+fcorr)*1i);
        error = conj(osc_ref(j)) * sig(j);
        
        insterror(j) = atan2(imag(error), real(error));
        
        pcorr = pcorr + phasecoef * insterror(j);
        fcorr = fcorr + freqcoef * insterror(j);
        pcorr = pcorr + fcorr; % Why are we incrementing pcorr twice ?
        
        fcorrd(j) = fcorr; 
    end
    
    endfreq = fcorrd;
    carrier = osc_ref;
    
end
