#include <QCoreApplication>
#include <string>
#include <iostream>
#include <ios>
#include <fstream>
#include <iomanip>

#include "../../qt_vna/adf4355.h"

int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);

    ADF4355 * pllRef = new ADF4355(122.88*1e6, (uint64_t)(3.4*1e9), (uint64_t)(6.8*1e9), 61.44*1e6, 0);
    pllRef->initFreqRange((uint64_t)2*1e9,
                          (uint64_t)6*1e9,
                          (uint64_t)10);

    ADF4355 * pllGen = new ADF4355(25*1e6, (uint64_t)(3.4*1e9), (uint64_t)(6.8*1e9), 50*1e6, 1);
    pllGen->initFreqRange((uint64_t)4*1e9,
                          (uint64_t)6*1e9,
                          (uint64_t)10);

    for(uint8_t j = 0; j < 10; j++) {

        uint8_t *d1;
        d1 = pllRef->getBytes(j);

        uint8_t *d2;
        d2 = pllRef->getBytes(j);

        std::string refpath = ".\\ref_" + std::to_string(j) + ".csv";
        std::string genpath = ".\\gen_" + std::to_string(j) + ".csv";

        std::ofstream reffile;
        std::ofstream genfile;

        reffile.open(refpath, std::ios_base::out);
        genfile.open(genpath, std::ios_base::out);

        for(uint8_t k = 0; k < 70; k+=5) {
            reffile << std::hex << (uint32_t)d1[k] << " " << std::hex << (uint32_t)d1[k+1] << std::hex << (uint32_t)d1[k+2] << std::hex << (uint32_t)d1[k+3] << std::hex << (uint32_t)d1[k+4] << std::endl;
            genfile << std::hex << (uint32_t)d2[k] << " " << std::hex << (uint32_t)d2[k+1] << std::hex << (uint32_t)d2[k+2] << std::hex << (uint32_t)d2[k+3] << std::hex << (uint32_t)d2[k+4] << std::endl;
        }

        reffile.close();
        genfile.close();
    }

    // Debug crap
    std::string path = ".\\pll_debug.csv";
    std::ofstream file;

    file.open(path, std::ios_base::out);

    for(uint8_t i = 0; i < 10; i++) {
        uint64_t refF = pllRef->freqParams[i].getCalcFreq();
        uint64_t genF = pllGen->freqParams[i].getCalcFreq();

        printf("%d - %llu - %llu - %lld\n",i, refF, genF, refF-genF);

        file << refF << ";" << genF << std::endl;
    }

    file.close();

    return a.exec();
}
