#ifndef FFT_WRAP_H
#define FFT_WRAP_H

#include <cmath>
#include <complex>

#if defined(_WIN32) || defined(WIN32)
    #include "fftw-3.3.5-64/fftw3.h"
#elif defined(__linux__)
    #include <fftw3.h>
#endif

#define FFTSIZE 8192

/*
 * Generates the Analytic signal
 * xs(t) is real
 * xa(t) = xs(t) + j H(xs(t))
 */
void analytic(fftw_complex*in, uint16_t size, bool dcrem);

double pll(std::complex<double> * in, std::complex<double> *& out, uint16_t size);

std::complex<double> convol1pt(std::complex<double> * ref, std::complex<double> * sig, uint16_t start_offset);

double mag2db(double mag);

#endif // FFT_WRAP_H
