#include "ftdiwrap.h"

FTDI::FTDI() {

}

FTDI::~FTDI() {
    if(this->valid == true) {
        FT_Close(this->openedVNA);
    }
}

FTDIErr FTDI::init()
{
    DWORD numDevs = 0;
    FT_DEVICE_LIST_INFO_NODE *devInfo;
    uint8_t vnaIndex = 255;

    this->ft_status = FT_CreateDeviceInfoList(&numDevs);
    if(this->ft_status == FT_OK && numDevs > 0) {
        devInfo = (FT_DEVICE_LIST_INFO_NODE *)std::malloc(sizeof(FT_DEVICE_LIST_INFO_NODE)*numDevs);
        this->ft_status = FT_GetDeviceInfoList(devInfo, &numDevs);
        if(this->ft_status == FT_OK) {
            for(uint8_t i = 0; i < numDevs; i++) {
                if(strncmp(VNADESC, devInfo[i].Description, 3) == 0) { // Not really a safe comparison !
                    vnaIndex = i;
                    break;
                }
            }
        }

        if(vnaIndex == 255) return NOTFOUND;
        this->ft_status = FT_Open(vnaIndex, &openedVNA);
        if(this->ft_status == FT_OK) {
            this->valid = true;
            return OK;
        } else {
            return NOTFOUND;
        }

    } else {
        return NOTFOUND;
    }
}

FTDIErr FTDI::set245Mode(){
    uint8_t mask = 0x00;
    uint8_t mode = 0x40;

    this->ft_status = FT_SetBitMode(this->openedVNA, mask, mode);
    if(this->ft_status == FT_OK) {
        return OK;
    } else {
        FT_Close(this->openedVNA);
        this->valid = false;
        return CANTSETMODE;
    }
}

FTDIErr FTDI::setLatency(uint8_t msec) {
    this->ft_status = FT_SetLatencyTimer(this->openedVNA, msec);
    if(this->ft_status == FT_OK) {
        return OK;
    } else {
        FT_Close(this->openedVNA);
        this->valid = false;
        return CANTSETLATENCY;
    }
}

FTDIErr FTDI::sendData(uint8_t * data, uint64_t length, DWORD * wrote) {
    this->ft_status = FT_Write(this->openedVNA, data, length, wrote);
    if(length != *wrote) {
        return CANTSENDALL;
    } else {
        return OK;
    }
}

FTDIErr FTDI::readData(uint8_t * data, uint64_t length, DWORD * red) {
    this->ft_status = FT_Read(this->openedVNA, data, length, red);
    if(length != *red) {
        return CANTREADALL;
    } else {
        return OK;
    }
}

FTDIErr FTDI::getNbBytes(DWORD * toread) {
    this->ft_status = FT_GetQueueStatus(this->openedVNA, toread);
    return OK;
}
