#ifndef FTDI_H
#define FTDI_H

// FTDI library
#if defined(_WIN32) || defined(WIN32)
    #include <windows.h>
    #include <ftdi/ftd2xx.h>
#elif defined(__linux__)
    #include <ftdi/linux/ftd2xx.h>
    #include <string.h>
    #include <cstdlib>

    #define DWORD uint32_t
#endif


#include <stdint.h>

#define VNADESC         "VNA"

typedef enum {
    OK                  = 0,
    NOTFOUND			= 1,
    UNDEFINED           = 2,
    CANTSETMODE         = 3,
    CANTSENDALL         = 4,
    CANTREADALL         = 5,
    CANTSETLATENCY      = 6
} FTDIErr;

class FTDI
{
public:
    FTDI();
    ~FTDI();
    FTDIErr init();
    FTDIErr set245Mode();
    FTDIErr setLatency(uint8_t msec);
    FTDIErr sendData(uint8_t * data, uint64_t length, DWORD * wrote);
    FTDIErr readData(uint8_t * data, uint64_t length, DWORD * red);
    FTDIErr getNbBytes(DWORD * toread);

private:
    bool valid = false;
    int ft_status;
    FT_HANDLE openedVNA;

};

#endif // FTDI_H
