#ifndef MYGLWIDGET_H
#define MYGLWIDGET_H

#include <QWidget>
#include <QPainter>
#include <QOpenGLWidget>
#include <QMouseEvent>

#define MAXMARKERS      16

class MyGLWidget : public QOpenGLWidget
{
    Q_OBJECT

public:
    MyGLWidget(QWidget *parent);
    QPointF *mag = 0;
    QPointF *ang = 0;
    uint16_t size = 0;

    void setSize(uint16_t size);

    // For debug
    QPointF *refmag = 0;

signals:
    void sendMarkPoint(const QPointF *p);

protected:
    void paintEvent(QPaintEvent *event) override;
    void mousePressEvent(QMouseEvent *event) override;
    void mouseMoveEvent(QMouseEvent *event) override;

};

#endif // MYGLWIDGET_H
