#ifndef MYSMITHWIDGET_H
#define MYSMITHWIDGET_H

#include <QWidget>
#include <QPainter>
#include <QOpenGLWidget>
#include <complex>

const uint32_t scNbCircle = 6;

class MySmithWidget : public QOpenGLWidget
{
    Q_OBJECT

public:
    MySmithWidget(QWidget *parent);
    void setSize(uint16_t size);

    std::complex<double> *SList;
    QPointF *dispList;
    uint16_t size = 0;

    double Z0 = 50.0;
    double ZDispList[scNbCircle] = {10.0, 25.0, 50.0, 100.0, 200.0, 500.0};

private:
    void drawSmith(QPainter *painter);
    void placeSPoint(QPaintEvent *event, std::complex<double> Sl, double Z0);
    void calcCircle();

protected:
    void paintEvent(QPaintEvent *event) override;
};

#endif // MYSMITHWIDGET_H
