`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    23:26:06 01/21/2018 
// Design Name: 
// Module Name:    top_tb 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module top_tb(
    );
	 
	 reg clk = 0;
	 always #1 clk <= ~clk;
	 
	 reg slow_clk = 0;
	 always #2 slow_clk <= ~slow_clk;
	 
	 reg NRXF = 1;
	 reg NTXE = 1;
	 wire NRD;
	 wire NWR;
	 wire NOE;
	 
	 reg [7:0]DATA = 0;
	 wire [7:0]FDATA = NOE ? 8'dZ : DATA;
	
	top mytop(.clk24(slow_clk),
					.FT_CLK(clk), .NRXF(NRXF),
					.NTXE(NTXE), .NRD(NRD),
					.NWR(NWR), .NOE(NOE),
					.FDATA(FDATA));
					
					
	localparam IDLE = 0;
	localparam RXFLOW = 1;
	localparam FIRSTBYTE = 2;
	localparam SECONDBYTE = 3;
	localparam THIRDBYTE = 4;
	localparam FORTHBYTE = 5;
	localparam WAIT = 10;
	
	reg [3:0]state = IDLE;
					
	always @(posedge clk)
	begin
		NRXF <= 1;
		NTXE <= 0;
		case(state)
			IDLE: begin
				state <= RXFLOW;
				NRXF <= 1;
			end
			
			RXFLOW: begin
				NRXF <= 0;
				if(!NRD && !NOE) begin
					DATA <= 8'h81;
					state <= FIRSTBYTE;
				end else if(!NOE) begin
					DATA <= 8'h01;
				end
			end
			
			FIRSTBYTE: begin
				DATA <= 8'h03;
				NRXF <= 0;
				state <= SECONDBYTE;
			end
			
			SECONDBYTE: begin
				DATA <= 8'h04;
				NRXF <= 0;
				state <= THIRDBYTE;
			end
			
			THIRDBYTE: begin
				DATA <= 8'hFF;
				NRXF <= 0;
				state <= WAIT;
			end
			
			FORTHBYTE: begin
				DATA <= 8'h45;
				NRXF <= 0;
				state <= IDLE;
			end
			
			WAIT: begin
				state <= IDLE;
			end
		endcase
	end


endmodule
